package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.GameTeamBo;
import org.dromara.system.domain.vo.GameTeamVo;
import org.dromara.system.domain.GameTeam;
import org.dromara.system.mapper.GameTeamMapper;
import org.dromara.system.service.IGameTeamService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 参赛队伍Service业务层处理
 *
 * @author zlt
 * @date 2025-07-30
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class GameTeamServiceImpl implements IGameTeamService {

    private final GameTeamMapper baseMapper;

    /**
     * 查询参赛队伍
     *
     * @param teamId 主键
     * @return 参赛队伍
     */
    @Override
    public GameTeamVo queryById(Long teamId){
        return baseMapper.selectVoById(teamId);
    }

    /**
     * 分页查询参赛队伍列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 参赛队伍分页列表
     */
    @Override
    public TableDataInfo<GameTeamVo> queryPageList(GameTeamBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<GameTeam> lqw = buildQueryWrapper(bo);
        Page<GameTeamVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的参赛队伍列表
     *
     * @param bo 查询条件
     * @return 参赛队伍列表
     */
    @Override
    public List<GameTeamVo> queryList(GameTeamBo bo) {
        LambdaQueryWrapper<GameTeam> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<GameTeam> buildQueryWrapper(GameTeamBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<GameTeam> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(GameTeam::getTeamId);
        lqw.eq(bo.getEventId() != null, GameTeam::getEventId, bo.getEventId());
        lqw.like(StringUtils.isNotBlank(bo.getTeamName()), GameTeam::getTeamName, bo.getTeamName());
        lqw.eq(StringUtils.isNotBlank(bo.getTeamCode()), GameTeam::getTeamCode, bo.getTeamCode());
        lqw.eq(StringUtils.isNotBlank(bo.getLeader()), GameTeam::getLeader, bo.getLeader());
        lqw.eq(StringUtils.isNotBlank(bo.getAthleteValue()), GameTeam::getAthleteValue, bo.getAthleteValue());
        lqw.eq(StringUtils.isNotBlank(bo.getProjectValue()), GameTeam::getProjectValue, bo.getProjectValue());
        lqw.eq(bo.getAthleteNum() != null, GameTeam::getAthleteNum, bo.getAthleteNum());
        lqw.eq(StringUtils.isNotBlank(bo.getNumberRange()), GameTeam::getNumberRange, bo.getNumberRange());
        lqw.eq(StringUtils.isNotBlank(bo.getTeamDescribe()), GameTeam::getTeamDescribe, bo.getTeamDescribe());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), GameTeam::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增参赛队伍
     *
     * @param bo 参赛队伍
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(GameTeamBo bo) {
        GameTeam add = MapstructUtils.convert(bo, GameTeam.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setTeamId(add.getTeamId());
        }
        return flag;
    }

    /**
     * 修改参赛队伍
     *
     * @param bo 参赛队伍
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(GameTeamBo bo) {
        GameTeam update = MapstructUtils.convert(bo, GameTeam.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(GameTeam entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除参赛队伍信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
